import { Request, Response, NextFunction } from 'express';
import { CustomLocals } from '../types/common';
import { Model } from 'mongoose';
declare function keycloakConfig(realm: string, authUrl: string, clientId: string, clientSecret: string, username: string, password: string): any;
interface UserPayload {
    sid: string;
    azp: string;
    name: string;
    preferred_username: string;
    given_name: string;
    family_name: string;
    email: string;
    typ: 'Bearer';
    realm_access: object;
    resource_access: object;
}
interface CurrentUser {
    currentUser: UserPayload;
}
interface AuthMiddleware {
    currentUser<T>(User: Model<T>): (req: Request, res: Response<any, CustomLocals.CurrentUserDataLocals<T>>, next: NextFunction) => {};
}
declare class AuthMiddleware implements AuthMiddleware {
    private static _instance;
    private constructor();
    static getInstance(): AuthMiddleware;
    private decodeAccessToken;
    private verifyOnlineAccessToken;
    private verifyOfflineAccessToken;
    private createUser;
}
export { keycloakConfig, UserPayload, CurrentUser, AuthMiddleware };
